Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision d8b94a86944c4679c88bc250bff510f242d63309)
+++ src/moleculelist.cpp	(revision 1907a789609146bbdebfeff09de44cb4ba21b808)
@@ -1,6 +1,6 @@
 /** \file MoleculeListClass.cpp
- * 
+ *
  * Function implementations for the class MoleculeListClass.
- * 
+ *
  */
 
@@ -13,19 +13,8 @@
 MoleculeListClass::MoleculeListClass()
 {
-};
-
-/** constructor for MoleculeListClass.
- * \param NumMolecules number of molecules to allocate for
- * \param NumAtoms number of atoms to allocate for
- */
-MoleculeListClass::MoleculeListClass(int NumMolecules, int NumAtoms)
-{
-	ListOfMolecules = (molecule **) Malloc(sizeof(molecule *)*NumMolecules, "MoleculeListClass:MoleculeListClass: **ListOfMolecules");
-	for (int i=NumMolecules;i--;)
-		ListOfMolecules[i] = NULL;
-	NumberOfMolecules = NumMolecules;
-	NumberOfTopAtoms = NumAtoms;
-};
-
+  // empty lists
+  ListOfMolecules.clear();
+  MaxIndex = 1;
+};
 
 /** Destructor for MoleculeListClass.
@@ -33,14 +22,21 @@
 MoleculeListClass::~MoleculeListClass()
 {
-	cout << Verbose(3) << this << ": Freeing ListOfMolcules." << endl;
-	for (int i=NumberOfMolecules;i--;) {
-		if (ListOfMolecules[i] != NULL) { // if NULL don't free
-			cout << Verbose(4) << "ListOfMolecules: Freeing " << ListOfMolecules[i] << "." << endl;
-			delete(ListOfMolecules[i]);
-			ListOfMolecules[i] = NULL;
-		}
-	}
-	cout << Verbose(4) << "Freeing ListOfMolecules." << endl;
-	Free((void **)&ListOfMolecules, "MoleculeListClass:MoleculeListClass: **ListOfMolecules");
+  cout << Verbose(3) << this << ": Freeing ListOfMolcules." << endl;
+  for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
+    cout << Verbose(4) << "ListOfMolecules: Freeing " << *ListRunner << "." << endl;
+    delete (*ListRunner);
+  }
+  cout << Verbose(4) << "Freeing ListOfMolecules." << endl;
+  ListOfMolecules.clear(); // empty list
+};
+
+/** Insert a new molecule into the list and set its number.
+ * \param *mol molecule to add to list.
+ * \return true - add successful
+ */
+bool MoleculeListClass::insert(molecule *mol)
+{
+  mol->IndexNr = MaxIndex++;
+  ListOfMolecules.push_back(mol);
 };
 
@@ -52,72 +48,259 @@
 int MolCompare(const void *a, const void *b)
 {
-	int *aList = NULL, *bList = NULL;
-	int Count, Counter, aCounter, bCounter;
-	int flag;
-	atom *aWalker = NULL;
-	atom *bWalker = NULL;
-	
-	// sort each atom list and put the numbers into a list, then go through
-	//cout << "Comparing fragment no. " << *(molecule **)a << " to " << *(molecule **)b << "." << endl;
-	if ( (**(molecule **)a).AtomCount < (**(molecule **)b).AtomCount ) {
-		return -1;
-	} else { if ((**(molecule **)a).AtomCount > (**(molecule **)b).AtomCount)
-		return +1;
-		else {
-			Count = (**(molecule **)a).AtomCount;
-			aList = new int[Count];
-			bList = new int[Count];
-	
-			// fill the lists
-			aWalker = (**(molecule **)a).start;
-			bWalker = (**(molecule **)b).start;
-			Counter = 0;
-			aCounter = 0;
-			bCounter = 0;
-			while ((aWalker->next != (**(molecule **)a).end) && (bWalker->next != (**(molecule **)b).end)) {
-				aWalker = aWalker->next;
-				bWalker = bWalker->next;
-				if (aWalker->GetTrueFather() == NULL)
-					aList[Counter] = Count + (aCounter++);
-				else
-					aList[Counter] = aWalker->GetTrueFather()->nr;
-				if (bWalker->GetTrueFather() == NULL)
-					bList[Counter] = Count + (bCounter++);
-				else
-					bList[Counter] = bWalker->GetTrueFather()->nr;
-				Counter++;
-			}
-			// check if AtomCount was for real
-			flag = 0;
-			if ((aWalker->next == (**(molecule **)a).end) && (bWalker->next != (**(molecule **)b).end)) {
-				flag = -1;
-			} else {
-				if ((aWalker->next != (**(molecule **)a).end) && (bWalker->next == (**(molecule **)b).end))
-					flag = 1;
-			}
-			if (flag == 0) {
-				// sort the lists
-				gsl_heapsort(aList,Count, sizeof(int), CompareDoubles); 
-				gsl_heapsort(bList,Count, sizeof(int), CompareDoubles);
-				// compare the lists 
-				
-				flag = 0;
-				for(int i=0;i<Count;i++) {
-					if (aList[i] < bList[i]) {
-						flag = -1;
-					} else {
-						if (aList[i] > bList[i])
-							flag = 1;
-					}
-					if (flag != 0)
-						break;
-				}
-			}
-			delete[](aList);
-			delete[](bList);
-			return flag;
-		}
-	}
-	return	-1;
+  int *aList = NULL, *bList = NULL;
+  int Count, Counter, aCounter, bCounter;
+  int flag;
+  atom *aWalker = NULL;
+  atom *bWalker = NULL;
+
+  // sort each atom list and put the numbers into a list, then go through
+  //cout << "Comparing fragment no. " << *(molecule **)a << " to " << *(molecule **)b << "." << endl;
+  if ((**(molecule **) a).AtomCount < (**(molecule **) b).AtomCount) {
+    return -1;
+  } else {
+    if ((**(molecule **) a).AtomCount > (**(molecule **) b).AtomCount)
+      return +1;
+    else {
+      Count = (**(molecule **) a).AtomCount;
+      aList = new int[Count];
+      bList = new int[Count];
+
+      // fill the lists
+      aWalker = (**(molecule **) a).start;
+      bWalker = (**(molecule **) b).start;
+      Counter = 0;
+      aCounter = 0;
+      bCounter = 0;
+      while ((aWalker->next != (**(molecule **) a).end) && (bWalker->next != (**(molecule **) b).end)) {
+        aWalker = aWalker->next;
+        bWalker = bWalker->next;
+        if (aWalker->GetTrueFather() == NULL)
+          aList[Counter] = Count + (aCounter++);
+        else
+          aList[Counter] = aWalker->GetTrueFather()->nr;
+        if (bWalker->GetTrueFather() == NULL)
+          bList[Counter] = Count + (bCounter++);
+        else
+          bList[Counter] = bWalker->GetTrueFather()->nr;
+        Counter++;
+      }
+      // check if AtomCount was for real
+      flag = 0;
+      if ((aWalker->next == (**(molecule **) a).end) && (bWalker->next != (**(molecule **) b).end)) {
+        flag = -1;
+      } else {
+        if ((aWalker->next != (**(molecule **) a).end) && (bWalker->next == (**(molecule **) b).end))
+          flag = 1;
+      }
+      if (flag == 0) {
+        // sort the lists
+        gsl_heapsort(aList, Count, sizeof(int), CompareDoubles);
+        gsl_heapsort(bList, Count, sizeof(int), CompareDoubles);
+        // compare the lists
+
+        flag = 0;
+        for (int i = 0; i < Count; i++) {
+          if (aList[i] < bList[i]) {
+            flag = -1;
+          } else {
+            if (aList[i] > bList[i])
+              flag = 1;
+          }
+          if (flag != 0)
+            break;
+        }
+      }
+      delete[] (aList);
+      delete[] (bList);
+      return flag;
+    }
+  }
+  return -1;
+};
+
+/** Output of a list of all molecules.
+ * \param *out output stream
+ */
+void MoleculeListClass::Enumerate(ofstream *out)
+{
+  int i=1;
+  element* Elemental = NULL;
+  atom *Walker = NULL;
+  int Counts[MAX_ELEMENTS];
+
+  // header
+  *out << "Index\tName\tNo.Atoms\tformula" << endl;
+  cout << Verbose(0) << "-----------------------------------------------" << endl;
+  if (ListOfMolecules.size() == 0)
+    *out << "\tNone" << endl;
+  else {
+    for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
+      // reset element counts
+      for (int j = 0; j<MAX_ELEMENTS;j++)
+        Counts[j] = 0;
+      // count atoms per element
+      Walker = (*ListRunner)->start;
+      while (Walker->next != (*ListRunner)->end) {
+        Walker = Walker->next;
+        Counts[Walker->type->Z]++;
+      }
+      // output Index, Name, number of atoms, chemical formula
+      *out << ((*ListRunner)->ActiveFlag ? "*" : " ") << (*ListRunner)->IndexNr << "\t" << (*ListRunner)->name << "\t\t" << (*ListRunner)->AtomCount << "\t";
+      Elemental = (*ListRunner)->elemente->end;
+      while(Elemental != (*ListRunner)->elemente->start) {
+        Elemental = Elemental->previous;
+        if (Counts[Elemental->Z] != 0)
+          *out << Elemental->symbol << Counts[Elemental->Z];
+      }
+      *out << endl;
+    }
+  }
+};
+
+/** Returns the molecule with the given index \a index.
+ * \param index index of the desired molecule
+ * \return pointer to molecule structure, NULL if not found
+ */
+molecule * MoleculeListClass::ReturnIndex(int index)
+{
+  int count = 1;
+  MoleculeList::iterator ListRunner = ListOfMolecules.begin();
+  for(; ((ListRunner != ListOfMolecules.end()) && (count < index)); ListRunner++);
+  if (count == index)
+    return (*ListRunner);
+  else
+    return NULL;
+};
+
+/** Simple merge of two molecules into one.
+ * \param *mol destination molecule
+ * \param *srcmol source molecule
+ * \return true - merge successful, false - merge failed (probably due to non-existant indices
+ */
+bool MoleculeListClass::SimpleMerge(molecule *mol, molecule *srcmol)
+{
+  if (srcmol == NULL)
+    return false;
+
+  // put all molecules of src into mol
+  atom *Walker = srcmol->start;
+  atom *NextAtom = Walker->next;
+  while (NextAtom != srcmol->end) {
+    Walker = NextAtom;
+    NextAtom = Walker->next;
+    srcmol->UnlinkAtom(Walker);
+    mol->AddAtom(Walker);
+  }
+
+  // remove src
+  ListOfMolecules.remove(srcmol);
+  delete(srcmol);
+  return true;
+};
+
+/** Simple add of one molecules into another.
+ * \param *mol destination molecule
+ * \param *srcmol source molecule
+ * \return true - merge successful, false - merge failed (probably due to non-existant indices
+ */
+bool MoleculeListClass::SimpleAdd(molecule *mol, molecule *srcmol)
+{
+  if (srcmol == NULL)
+    return false;
+
+  // put all molecules of src into mol
+  atom *Walker = srcmol->start;
+  atom *NextAtom = Walker->next;
+  while (NextAtom != srcmol->end) {
+    Walker = NextAtom;
+    NextAtom = Walker->next;
+    Walker = mol->AddCopyAtom(Walker);
+    Walker->father = Walker;
+  }
+
+  return true;
+};
+
+/** Simple merge of a given set of molecules into one.
+ * \param *mol destination molecule
+ * \param *src index of set of source molecule
+ * \param N number of source molecules
+ * \return true - merge successful, false - some merges failed (probably due to non-existant indices)
+ */
+bool MoleculeListClass::SimpleMultiMerge(molecule *mol, int *src, int N)
+{
+  bool status = true;
+  // check presence of all source molecules
+  for (int i=0;i<N;i++) {
+    molecule *srcmol = ReturnIndex(src[i]);
+    status = status && SimpleMerge(mol, srcmol);
+  }
+  return status;
+};
+
+/** Simple add of a given set of molecules into one.
+ * \param *mol destination molecule
+ * \param *src index of set of source molecule
+ * \param N number of source molecules
+ * \return true - merge successful, false - some merges failed (probably due to non-existant indices)
+ */
+bool MoleculeListClass::SimpleMultiAdd(molecule *mol, int *src, int N)
+{
+  bool status = true;
+  // check presence of all source molecules
+  for (int i=0;i<N;i++) {
+    molecule *srcmol = ReturnIndex(src[i]);
+    status = status && SimpleAdd(mol, srcmol);
+  }
+  return status;
+};
+
+/** Scatter merge of a given set of molecules into one.
+ * Scatter merge distributes the molecules in such a manner that they don't overlap.
+ * \param *mol destination molecule
+ * \param *src index of set of source molecule
+ * \param N number of source molecules
+ * \return true - merge successful, false - merge failed (probably due to non-existant indices
+ * \TODO find scatter center for each src molecule
+ */
+bool MoleculeListClass::ScatterMerge(molecule *mol, int *src, int N)
+{
+  // check presence of all source molecules
+  for (int i=0;i<N;i++) {
+    // get pointer to src molecule
+    molecule *srcmol = ReturnIndex(src[i]);
+    if (srcmol == NULL)
+      return false;
+  }
+  // adapt each Center
+  for (int i=0;i<N;i++) {
+    // get pointer to src molecule
+    molecule *srcmol = ReturnIndex(src[i]);
+    //srcmol->Center.Zero();
+    srcmol->Translate(&srcmol->Center);
+  }
+  // perform a simple multi merge
+  SimpleMultiMerge(mol, src, N);
+  return true;
+};
+
+/** Embedding merge of a given set of molecules into one.
+ * Embedding merge inserts one molecule into the other.
+ * \param *mol destination molecule
+ * \param *srcmol source molecule
+ * \return true - merge successful, false - merge failed (probably due to non-existant indices
+ * \TODO find embedding center
+ */
+bool MoleculeListClass::EmbedMerge(molecule *mol, molecule *srcmol)
+{
+  if (srcmol == NULL)
+    return false;
+
+  // calculate center for merge
+  //srcmol->Center.Zero();
+
+  // perform simple merge
+  SimpleMerge(mol, srcmol);
+  return true;
 };
 
@@ -127,8 +310,8 @@
 void MoleculeListClass::Output(ofstream *out)
 {
-	*out<< Verbose(1) << "MoleculeList: ";
-	for (int i=0;i<NumberOfMolecules;i++)
-		*out << ListOfMolecules[i] << "\t";
-	*out << endl;
+  *out << Verbose(1) << "MoleculeList: ";
+  for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++)
+    *out << *ListRunner << "\t";
+  *out << endl;
 };
 
@@ -142,181 +325,183 @@
 bool MoleculeListClass::AddHydrogenCorrection(ofstream *out, char *path)
 {
-	atom *Walker = NULL;
-	atom *Runner = NULL;
-	double ***FitConstant = NULL, **correction = NULL;
-	int a,b;
-	ofstream output;
-	ifstream input;
-	string line;
-	stringstream zeile;
-	double distance;
-	char ParsedLine[1023];
-	double tmp;
-	char *FragmentNumber = NULL;
-
-	cout << Verbose(1) << "Saving hydrogen saturation correction ... ";
-	// 0. parse in fit constant files that should have the same dimension as the final energy files
-	// 0a. find dimension of matrices with constants
-	line = path;
-	line.append("/");
-	line += FRAGMENTPREFIX;
-	line += "1";
-	line += FITCONSTANTSUFFIX;
-	input.open(line.c_str());
-	if (input == NULL) {
-		cerr << endl << "Unable to open " << line << ", is the directory correct?" << endl;
-		return false;
-	}
-	a=0;
-	b=-1; // we overcount by one 
-	while (!input.eof()) {
-		input.getline(ParsedLine, 1023);
-		zeile.str(ParsedLine);
-		int i=0;
-		while (!zeile.eof()) {
-			zeile >> distance;
-			i++;
-		}
-		if (i > a) 
-			a = i; 
-		b++;
-	}
-	cout << "I recognized " << a << " columns and " << b << " rows, ";
-	input.close();
-	
-	// 0b. allocate memory for constants
-	FitConstant = (double ***) Malloc(sizeof(double **)*3, "MoleculeListClass::AddHydrogenCorrection: ***FitConstant");
-	for (int k=0;k<3;k++) {
-		FitConstant[k] = (double **) Malloc(sizeof(double *)*a, "MoleculeListClass::AddHydrogenCorrection: **FitConstant[]");
-		for (int i=a;i--;) {
-			FitConstant[k][i] = (double *) Malloc(sizeof(double)*b, "MoleculeListClass::AddHydrogenCorrection: *FitConstant[][]");
-		}
-	}
-	// 0c. parse in constants
-	for (int i=0;i<3;i++) {
-		line = path;
-		line.append("/");
-		line += FRAGMENTPREFIX;
-		sprintf(ParsedLine, "%d", i+1);
-		line += ParsedLine;
-		line += FITCONSTANTSUFFIX;
-		input.open(line.c_str());
-		if (input == NULL) {
-			cerr << endl << "Unable to open " << line << ", is the directory correct?" << endl;
-			return false;
-		}
-		int k = 0,l;
-		while ((!input.eof()) && (k < b)) {
-			input.getline(ParsedLine, 1023);
-			//cout << "Current Line: " << ParsedLine << endl;
-			zeile.str(ParsedLine);
-			zeile.clear();
-			l = 0;
-			while ((!zeile.eof()) && (l < a)) {
-				zeile >> FitConstant[i][l][k];
-				//cout << FitConstant[i][l][k] << "\t";
-				l++;
-			}
-			//cout << endl;
-			k++;
-		}
-		input.close();
-	}
-	for(int k=0;k<3;k++) {
-		cout << "Constants " << k << ":" << endl;
-		for (int j=0;j<b;j++) {
-			for (int i=0;i<a;i++) {
-				cout << FitConstant[k][i][j] << "\t";
-			}
-			cout << endl;
-		}
-		cout << endl;
-	}
-	
-	// 0d. allocate final correction matrix
-	correction = (double **) Malloc(sizeof(double *)*a, "MoleculeListClass::AddHydrogenCorrection: **correction");
-	for (int i=a;i--;)
-		correction[i] = (double *) Malloc(sizeof(double)*b, "MoleculeListClass::AddHydrogenCorrection: *correction[]");
-				
-	// 1a. go through every molecule in the list
-	for(int i=NumberOfMolecules;i--;) {
-		// 1b. zero final correction matrix
-		for (int k=a;k--;)
-			for (int j=b;j--;)
-				correction[k][j] = 0.;
-		// 2. take every hydrogen that is a saturated one
-		Walker = ListOfMolecules[i]->start;
-		while (Walker->next != ListOfMolecules[i]->end) {
-			Walker = Walker->next;
-			//cout << Verbose(1) << "Walker: " << *Walker << " with first bond " << *ListOfMolecules[i]->ListOfBondsPerAtom[Walker->nr][0] << "." << endl;
-			if ((Walker->type->Z == 1) && ((Walker->father == NULL) || (Walker->father->type->Z != 1))) { // if it's a hydrogen
-				Runner = ListOfMolecules[i]->start;
-				while (Runner->next != ListOfMolecules[i]->end) {
-					Runner = Runner->next;
-					//cout << Verbose(2) << "Runner: " << *Runner << " with first bond " << *ListOfMolecules[i]->ListOfBondsPerAtom[Runner->nr][0] << "." << endl;
-					// 3. take every other hydrogen that is the not the first and not bound to same bonding partner
-					if ((Runner->type->Z == 1) && (Runner->nr > Walker->nr) && (ListOfMolecules[i]->ListOfBondsPerAtom[Runner->nr][0]->GetOtherAtom(Runner) != ListOfMolecules[i]->ListOfBondsPerAtom[Walker->nr][0]->GetOtherAtom(Walker))) {	// (hydrogens have only one bonding partner!)
-						// 4. evaluate the morse potential for each matrix component and add up
-						distance = Runner->x.Distance(&Walker->x);
-						//cout << "Fragment " << i << ": " << *Runner << "<= " << distance << "=>" << *Walker << ":" << endl;
-						for(int k=0;k<a;k++) {
-							for (int j=0;j<b;j++) {
-								switch(k) {
-								case 1:
-								case 7:
-								case 11:
-									tmp = pow(FitConstant[0][k][j] * ( 1. - exp(-FitConstant[1][k][j] * (distance - FitConstant[2][k][j]) ) ),2);
-									break;
-								default:
-									tmp = FitConstant[0][k][j] * pow( distance,	FitConstant[1][k][j]) + FitConstant[2][k][j];
-								};
-								correction[k][j] -= tmp;		// ground state is actually lower (disturbed by additional interaction)
-								//cout << tmp << "\t";
-							}
-							//cout << endl;
-						}
-						//cout << endl;
-					}
-				}
-			}
-		}
-		// 5. write final matrix to file
-		line = path;
-		line.append("/");
-		line += FRAGMENTPREFIX;
-		FragmentNumber = FixedDigitNumber(NumberOfMolecules, i);
-		line += FragmentNumber;
-		delete(FragmentNumber);
-		line += HCORRECTIONSUFFIX;
-		output.open(line.c_str());
-		output << "Time\t\tTotal\t\tKinetic\t\tNonLocal\tCorrelation\tExchange\tPseudo\t\tHartree\t\t-Gauss\t\tEwald\t\tIonKin\t\tETotal" << endl;
-		for (int j=0;j<b;j++) {
-			for(int i=0;i<a;i++)
-				output << correction[i][j] << "\t";
-			output << endl;
-		}
-		output.close();
-	}
-	line = path;
-	line.append("/");
-	line += HCORRECTIONSUFFIX;
-	output.open(line.c_str());
-	output << "Time\t\tTotal\t\tKinetic\t\tNonLocal\tCorrelation\tExchange\tPseudo\t\tHartree\t\t-Gauss\t\tEwald\t\tIonKin\t\tETotal" << endl;
-	for (int j=0;j<b;j++) {
-		for(int i=0;i<a;i++)
-			output << 0 << "\t";
-		output << endl;
-	}
-	output.close();
-	// 6. free memory of parsed matrices
-	FitConstant = (double ***) Malloc(sizeof(double **)*a, "MoleculeListClass::AddHydrogenCorrection: ***FitConstant");
-	for (int k=0;k<3;k++) {
-		FitConstant[k] = (double **) Malloc(sizeof(double *)*a, "MoleculeListClass::AddHydrogenCorrection: **FitConstant[]");
-		for (int i=a;i--;) {
-			FitConstant[k][i] = (double *) Malloc(sizeof(double)*b, "MoleculeListClass::AddHydrogenCorrection: *FitConstant[][]");
-		}
-	}
-	cout << "done." << endl;
-	return true;
+  atom *Walker = NULL;
+  atom *Runner = NULL;
+  double ***FitConstant = NULL, **correction = NULL;
+  int a, b;
+  ofstream output;
+  ifstream input;
+  string line;
+  stringstream zeile;
+  double distance;
+  char ParsedLine[1023];
+  double tmp;
+  char *FragmentNumber = NULL;
+
+  cout << Verbose(1) << "Saving hydrogen saturation correction ... ";
+  // 0. parse in fit constant files that should have the same dimension as the final energy files
+  // 0a. find dimension of matrices with constants
+  line = path;
+  line.append("/");
+  line += FRAGMENTPREFIX;
+  line += "1";
+  line += FITCONSTANTSUFFIX;
+  input.open(line.c_str());
+  if (input == NULL) {
+    cerr << endl << "Unable to open " << line << ", is the directory correct?"
+        << endl;
+    return false;
+  }
+  a = 0;
+  b = -1; // we overcount by one
+  while (!input.eof()) {
+    input.getline(ParsedLine, 1023);
+    zeile.str(ParsedLine);
+    int i = 0;
+    while (!zeile.eof()) {
+      zeile >> distance;
+      i++;
+    }
+    if (i > a)
+      a = i;
+    b++;
+  }
+  cout << "I recognized " << a << " columns and " << b << " rows, ";
+  input.close();
+
+  // 0b. allocate memory for constants
+  FitConstant = (double ***) Malloc(sizeof(double **) * 3, "MoleculeListClass::AddHydrogenCorrection: ***FitConstant");
+  for (int k = 0; k < 3; k++) {
+    FitConstant[k] = (double **) Malloc(sizeof(double *) * a, "MoleculeListClass::AddHydrogenCorrection: **FitConstant[]");
+    for (int i = a; i--;) {
+      FitConstant[k][i] = (double *) Malloc(sizeof(double) * b, "MoleculeListClass::AddHydrogenCorrection: *FitConstant[][]");
+    }
+  }
+  // 0c. parse in constants
+  for (int i = 0; i < 3; i++) {
+    line = path;
+    line.append("/");
+    line += FRAGMENTPREFIX;
+    sprintf(ParsedLine, "%d", i + 1);
+    line += ParsedLine;
+    line += FITCONSTANTSUFFIX;
+    input.open(line.c_str());
+    if (input == NULL) {
+      cerr << endl << "Unable to open " << line << ", is the directory correct?" << endl;
+      return false;
+    }
+    int k = 0, l;
+    while ((!input.eof()) && (k < b)) {
+      input.getline(ParsedLine, 1023);
+      //cout << "Current Line: " << ParsedLine << endl;
+      zeile.str(ParsedLine);
+      zeile.clear();
+      l = 0;
+      while ((!zeile.eof()) && (l < a)) {
+        zeile >> FitConstant[i][l][k];
+        //cout << FitConstant[i][l][k] << "\t";
+        l++;
+      }
+      //cout << endl;
+      k++;
+    }
+    input.close();
+  }
+  for (int k = 0; k < 3; k++) {
+    cout << "Constants " << k << ":" << endl;
+    for (int j = 0; j < b; j++) {
+      for (int i = 0; i < a; i++) {
+        cout << FitConstant[k][i][j] << "\t";
+      }
+      cout << endl;
+    }
+    cout << endl;
+  }
+
+  // 0d. allocate final correction matrix
+  correction = (double **) Malloc(sizeof(double *) * a, "MoleculeListClass::AddHydrogenCorrection: **correction");
+  for (int i = a; i--;)
+    correction[i] = (double *) Malloc(sizeof(double) * b, "MoleculeListClass::AddHydrogenCorrection: *correction[]");
+
+  // 1a. go through every molecule in the list
+  for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
+    // 1b. zero final correction matrix
+    for (int k = a; k--;)
+      for (int j = b; j--;)
+        correction[k][j] = 0.;
+    // 2. take every hydrogen that is a saturated one
+    Walker = (*ListRunner)->start;
+    while (Walker->next != (*ListRunner)->end) {
+      Walker = Walker->next;
+      //cout << Verbose(1) << "Walker: " << *Walker << " with first bond " << *(*Runner)->ListOfBondsPerAtom[Walker->nr][0] << "." << endl;
+      if ((Walker->type->Z == 1) && ((Walker->father == NULL)
+          || (Walker->father->type->Z != 1))) { // if it's a hydrogen
+        Runner = (*ListRunner)->start;
+        while (Runner->next != (*ListRunner)->end) {
+          Runner = Runner->next;
+          //cout << Verbose(2) << "Runner: " << *Runner << " with first bond " << *(*Runner)->ListOfBondsPerAtom[Runner->nr][0] << "." << endl;
+          // 3. take every other hydrogen that is the not the first and not bound to same bonding partner
+          if ((Runner->type->Z == 1) && (Runner->nr > Walker->nr) && ((*ListRunner)->ListOfBondsPerAtom[Runner->nr][0]->GetOtherAtom(Runner) != (*ListRunner)->ListOfBondsPerAtom[Walker->nr][0]->GetOtherAtom(Walker))) { // (hydrogens have only one bonding partner!)
+            // 4. evaluate the morse potential for each matrix component and add up
+            distance = Runner->x.Distance(&Walker->x);
+            //cout << "Fragment " << (*ListRunner)->name << ": " << *Runner << "<= " << distance << "=>" << *Walker << ":" << endl;
+            for (int k = 0; k < a; k++) {
+              for (int j = 0; j < b; j++) {
+                switch (k) {
+                  case 1:
+                  case 7:
+                  case 11:
+                    tmp = pow(FitConstant[0][k][j] * (1. - exp(-FitConstant[1][k][j] * (distance - FitConstant[2][k][j]))), 2);
+                    break;
+                  default:
+                    tmp = FitConstant[0][k][j] * pow(distance, FitConstant[1][k][j]) + FitConstant[2][k][j];
+                };
+                correction[k][j] -= tmp; // ground state is actually lower (disturbed by additional interaction)
+                //cout << tmp << "\t";
+              }
+              //cout << endl;
+            }
+            //cout << endl;
+          }
+        }
+      }
+    }
+    // 5. write final matrix to file
+    line = path;
+    line.append("/");
+    line += FRAGMENTPREFIX;
+    FragmentNumber = FixedDigitNumber(ListOfMolecules.size(), (*ListRunner)->IndexNr);
+    line += FragmentNumber;
+    delete (FragmentNumber);
+    line += HCORRECTIONSUFFIX;
+    output.open(line.c_str());
+    output << "Time\t\tTotal\t\tKinetic\t\tNonLocal\tCorrelation\tExchange\tPseudo\t\tHartree\t\t-Gauss\t\tEwald\t\tIonKin\t\tETotal" << endl;
+    for (int j = 0; j < b; j++) {
+      for (int i = 0; i < a; i++)
+        output << correction[i][j] << "\t";
+      output << endl;
+    }
+    output.close();
+  }
+  line = path;
+  line.append("/");
+  line += HCORRECTIONSUFFIX;
+  output.open(line.c_str());
+  output << "Time\t\tTotal\t\tKinetic\t\tNonLocal\tCorrelation\tExchange\tPseudo\t\tHartree\t\t-Gauss\t\tEwald\t\tIonKin\t\tETotal" << endl;
+  for (int j = 0; j < b; j++) {
+    for (int i = 0; i < a; i++)
+      output << 0 << "\t";
+    output << endl;
+  }
+  output.close();
+  // 6. free memory of parsed matrices
+  FitConstant = (double ***) Malloc(sizeof(double **) * a, "MoleculeListClass::AddHydrogenCorrection: ***FitConstant");
+  for (int k = 0; k < 3; k++) {
+    FitConstant[k] = (double **) Malloc(sizeof(double *) * a, "MoleculeListClass::AddHydrogenCorrection: **FitConstant[]");
+    for (int i = a; i--;) {
+      FitConstant[k][i] = (double *) Malloc(sizeof(double) * b, "MoleculeListClass::AddHydrogenCorrection: *FitConstant[][]");
+    }
+  }
+  cout << "done." << endl;
+  return true;
 };
 
@@ -327,49 +512,50 @@
  * \return true - file written successfully, false - writing failed
  */
-bool MoleculeListClass::StoreForcesFile(ofstream *out, char *path, int *SortIndex)
-{
-	bool status = true;
-	ofstream ForcesFile;
-	stringstream line;
-	atom *Walker = NULL;
-	element *runner = NULL;
-
-	// open file for the force factors
-	*out << Verbose(1) << "Saving	force factors ... ";
-	line << path << "/" << FRAGMENTPREFIX << FORCESFILE;
-	ForcesFile.open(line.str().c_str(), ios::out);
-	if (ForcesFile != NULL) {
-		//cout << Verbose(1) << "Final AtomicForcesList: ";
-		//output << prefix << "Forces" << endl;
-		for(int j=0;j<NumberOfMolecules;j++) {
-			//if (TEList[j] != 0) {
-			runner = ListOfMolecules[j]->elemente->start;
-			while (runner->next != ListOfMolecules[j]->elemente->end) { // go through every element
-				runner = runner->next;
-				if (ListOfMolecules[j]->ElementsInMolecule[runner->Z]) { // if this element got atoms
-					Walker = ListOfMolecules[j]->start;
-					while (Walker->next != ListOfMolecules[j]->end) { // go through every atom of this element
-						Walker = Walker->next;
-						if (Walker->type->Z == runner->Z) {
-							if ((Walker->GetTrueFather() != NULL) && (Walker->GetTrueFather() != Walker)) {// if there is a rea
-								//cout << "Walker is " << *Walker << " with true father " << *( Walker->GetTrueFather()) << ", it
-								ForcesFile <<	SortIndex[Walker->GetTrueFather()->nr] << "\t";
-								} else	// otherwise a -1 to indicate an added saturation hydrogen
-									ForcesFile << "-1\t";
-							}
-						}
-					}
-			}
-			ForcesFile << endl;
-		}
-		ForcesFile.close();
-		*out << Verbose(1) << "done." << endl;
-	} else {
-		status = false;
-		*out << Verbose(1) << "failed to open file " << line.str() << "." << endl;
-	}
-	ForcesFile.close();
-	
-	return status;
+bool MoleculeListClass::StoreForcesFile(ofstream *out, char *path,
+    int *SortIndex)
+{
+  bool status = true;
+  ofstream ForcesFile;
+  stringstream line;
+  atom *Walker = NULL;
+  element *runner = NULL;
+
+  // open file for the force factors
+  *out << Verbose(1) << "Saving	force factors ... ";
+  line << path << "/" << FRAGMENTPREFIX << FORCESFILE;
+  ForcesFile.open(line.str().c_str(), ios::out);
+  if (ForcesFile != NULL) {
+    //cout << Verbose(1) << "Final AtomicForcesList: ";
+    //output << prefix << "Forces" << endl;
+    for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
+      runner = (*ListRunner)->elemente->start;
+      while (runner->next != (*ListRunner)->elemente->end) { // go through every element
+        runner = runner->next;
+        if ((*ListRunner)->ElementsInMolecule[runner->Z]) { // if this element got atoms
+          Walker = (*ListRunner)->start;
+          while (Walker->next != (*ListRunner)->end) { // go through every atom of this element
+            Walker = Walker->next;
+            if (Walker->type->Z == runner->Z) {
+              if ((Walker->GetTrueFather() != NULL) && (Walker->GetTrueFather() != Walker)) {// if there is a rea
+                //cout << "Walker is " << *Walker << " with true father " << *( Walker->GetTrueFather()) << ", it
+                ForcesFile << SortIndex[Walker->GetTrueFather()->nr] << "\t";
+              } else
+                // otherwise a -1 to indicate an added saturation hydrogen
+                ForcesFile << "-1\t";
+            }
+          }
+        }
+      }
+      ForcesFile << endl;
+    }
+    ForcesFile.close();
+    *out << Verbose(1) << "done." << endl;
+  } else {
+    status = false;
+    *out << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+  }
+  ForcesFile.close();
+
+  return status;
 };
 
